# Rust语言学习

Rust官网：https://www.rust-lang.org/

**注意：建议在Linux上完成Rust的学习，这能为你将来省去不少的麻烦**

## Rust入门学习
推荐的Rust入门学习教程：

Rust入门教程仓库：https://github.com/rust-lang/rustlings/
    -   入门教程仓库汉化：https://github.com/chinanf-boy/rustlings-zh）

## Rust进阶学习

如果你想进一步了解Rust的语言特性，这里推荐：
- Rust圣经（The Rust Programming Language）：https://doc.rust-lang.org/book/
- Rust By Example：https://doc.rust-lang.org/rust-by-example/index.html
- 如果你有更多想要了解的，可以前往Rust官网查阅官方的文档资料：
  - https://www.rust-lang.org/learn

## 对于自己学习程度的估量参考
如果你想加入DragonOS社区参与项目开发，那么你需要了解Rust的以下知识，并能使用rust完成一个linux下的小程序。

1. Rust的基本语法
2. 循环与分支选择的语法
3. 所有权的规则、内存与分配（Heap和Stack上的数据的所有权问题）
4. 引用与解引用，以及借用
5. struct的定义以及implement
6. Trait及其implement
7. package, crate，module及use关键字的使用
8. 枚举（enum，Result，Option）
9. 生命周期
10. 闭包（closure）和迭代器（Iterator）
11. 类型转换
12. 智能指针
13. Box、Arc等智能指针的作用
14. Rc和Arc等智能指针之间的区别
15. 内部可变性等等
16. 循环引用与自引用
17. 多线程并发编程（锁、Atomic原子操作等）
18. 全局变量
19. Unsafe Rust
20. 宏
